#!/usr/bin/perl -w

use strict;

my $hexdump_file = 'hexdump.txt';

open(F, $hexdump_file) || die "Cannot open file: $hexdump_file ($!)";

print "<table border='0' cellspacing='0' cellpadding='2'>\n";

my $i = 0;
while(<F>) {
	#00000000  f5 01 00 00 02 00 00 00  00 00 00 00 00 00 00 00  |...............|
	#00000010  54 86 e7 0b 00 00 00 00  13 fe 52 12 a0 a6 96 c9  |T.......R. .|
	#00000020  89 bd f6 0b 00 00 00 00  1e 3a 8d 4c 87 4e cf 53  |.......:.L.NS|
	#00000030  01 00 00 00 01 00 00 00  77 77 77 2e 73 74 61 6e  |........www.stan|
	#00000040  66 6f 72 64 2e 65 64 75  2f 7e 70 61 6e 64 65 2f  |ford.edu/~pande/|
	#00000050  4c 69 6e 75 78 2f 78 38  36 2f 00 00 00 00 00 00  |Linux/x86/......|
	#00000060  00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00  |................|
	#00000070  00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00  |................|
	#00000080  00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00  |................|
	#00000090  00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00  |................|
	#000000a0  00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00  |................|
	#000000b0  00 00 00 00 00 00 00 00  f4 01 00 00 78 00 00 00  |...........x...|
	#000000c0  90 01 00 00 c0 ab 2e 00  00 00 00 00 00 00 00 00  |..............|
	#000000d0  00 00 00 00 00 00 00 00  61 09 28 00 15 00 01 00  |........a.(.....|
	#000000e0  86 c9 54 44 cf af ec 46  00 00 00 00 00 00 00 00  |.TDϯF........|
	#000000f0  00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00  |................|
	#...
	#00001c00
		
	# input offset in hexadecimal, 
	# followed by sixteen space-sepa-rated, two column, hexadecimal bytes, 
	# followed by the same sixteen bytes in %_p format enclosed in ``|'' characters.
	#
	# one hexbyte is one u32 unit
	
	#00000000  f5 01 00 00 02 00 00 00  00 00 00 00 00 00 00 00  |...............|
	if(/^([0-9a-f]{8})  ([0-9a-f ]{23})  ([0-9a-f ]{23})  \|(.*)\|\n$/) {
		my $offset = $1;
		my $bytes1 = $2;
		my $bytes2 = $3;
		my $bytesp = $4;

		my @hex1   = split / /, $bytes1;
		my @hex2   = split / /, $bytes2;
		
		print "<tr>\n";
		print " <td><pre>$offset</pre></td>\n";
		
		foreach(@hex1) {
			print " <td>&nbsp;</td>\n";
			print " <td><pre>$_</pre></td>\n";
		}
		print " <td>&nbsp;</td>\n";
		foreach(@hex2) {
			print " <td>&nbsp;</td>\n";
			print " <td><pre>$_</pre></td>\n";
		}
		
		print " <td>&nbsp;&nbsp;</td>\n";
		print " <td><pre>";
		print $bytesp if($bytesp);
		print "</pre></td>\n";
		print "</tr>\n";
	}
	#00001c00
	elsif(/^([0-9a-f]{8})\n$/) {
		my $offset = $1;
	
		print "<tr>";
		print " <td><pre>$offset</pre></td>\n";
		print " <td colspan='35'></td>\n";
		print "</tr>\n";
	}
	else {
		print "Cannot parse line $i: $_\n";
	}
	
	$i++;
}
print "</table>\n";

close F;

